Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.beans.factory.config
Class DestructionAwareAttributeHolder

    java.lang.Object
      org.springframework.beans.factory.config.DestructionAwareAttributeHolder

All Implemented Interfaces:
  java.io.Serializable

    public class DestructionAwareAttributeHolder

extends java.lang.Object
implements java.io.Serializable

A container object holding a map of attributes and optionally destruction callbacks. The callbacks will be invoked, if an attribute is being removed or if the holder is cleaned out.

Since:
  3.1
Author:
  Micha Kiener
See Also:
  Serialized Form

Constructor Summary
`DestructionAwareAttributeHolder()`

Method Summary
`void` | `clear()` Clears the map by removing all registered attribute values and invokes every destruction callback registered.
`java.lang.Object` | `getAttribute(java.lang.String name)` Returns the attribute having the specified name, if available, `null` otherwise.
`java.util.Map<java.lang.String,java.lang.Object>` | `getAttributeMap()` Returns the map representation of the registered attributes directly.
`java.lang.Runnable` | `getDestructionCallback(java.lang.String name, boolean remove)` Returns the destruction callback, if any registered for the attribute with the given name or `null` if no such callback was registered.
`void` | `registerDestructionCallback(java.lang.String name, java.lang.Runnable callback)` Register a callback to be executed on destruction of the specified object in the scope (or at destruction of the entire scope, if the scope does not destroy individual objects but rather only terminates in its entirety).
`java.lang.Object` | `removeAttribute(java.lang.String name)` Remove the object with the given `name` from the underlying scope.
`java.lang.Object` | `setAttribute(java.lang.String name, java.lang.Object value)` Puts the given object with the specified name as an attribute to the underlying map.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DestructionAwareAttributeHolder

    public DestructionAwareAttributeHolder()

Method Detail

### getAttributeMap

    public java.util.Map<java.lang.String,java.lang.Object> getAttributeMap()

  Returns the map representation of the registered attributes directly. Be aware to synchronize any invocations to it on the map object itself to avoid concurrent modification exceptions.

  Returns:
    the attributes as a map representation

### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)

  Returns the attribute having the specified name, if available, `null` otherwise.

  Parameters:
    `name` - the name of the attribute to be returned
  Returns:
    the attribute value or `null` if not available

### setAttribute

    public java.lang.Object setAttribute(java.lang.String name,
                                         java.lang.Object value)

  Puts the given object with the specified name as an attribute to the underlying map.

  Parameters:
    `name` - the name of the attribute
    `value` - the value to be stored
  Returns:
    any previously object stored under the same name, if any, `null` otherwise

### removeAttribute

    public java.lang.Object removeAttribute(java.lang.String name)

  Remove the object with the given `name` from the underlying scope.

  Returns `null` if no object was found; otherwise returns the removed `Object`.

  Note that an implementation should also remove a registered destruction callback for the specified object, if any. It does, however, not need to execute a registered destruction callback in this case, since the object will be destroyed by the caller (if appropriate).

  Note: This is an optional operation. Implementations may throw `UnsupportedOperationException` if they do not support explicitly removing an object.

  Parameters:
    `name` - the name of the object to remove
  Returns:
    the removed object, or `null` if no object was present
  See Also:
    `registerDestructionCallback(java.lang.String, java.lang.Runnable)`

### clear

    public void clear()

  Clears the map by removing all registered attribute values and invokes every destruction callback registered.

### registerDestructionCallback

    public void registerDestructionCallback(java.lang.String name,
                                            java.lang.Runnable callback)

  Register a callback to be executed on destruction of the specified object in the scope (or at destruction of the entire scope, if the scope does not destroy individual objects but rather only terminates in its entirety).

  Note: This is an optional operation. This method will only be called for scoped beans with actual destruction configuration (DisposableBean, destroy-method, DestructionAwareBeanPostProcessor). Implementations should do their best to execute a given callback at the appropriate time. If such a callback is not supported by the underlying runtime environment at all, the callback must be ignored and a corresponding warning should be logged.

  Note that 'destruction' refers to to automatic destruction of the object as part of the scope's own lifecycle, not to the individual scoped object having been explicitly removed by the application. If a scoped object gets removed via this facade's `removeAttribute(String)` method, any registered destruction callback should be removed as well, assuming that the removed object will be reused or manually destroyed.

  Parameters:
    `name` - the name of the object to execute the destruction callback for
    `callback` - the destruction callback to be executed. Note that the passed-in Runnable will never throw an exception, so it can safely be executed without an enclosing try-catch block. Furthermore, the Runnable will usually be serializable, provided that its target object is serializable as well.
  See Also:
    `DisposableBean`, `AbstractBeanDefinition.getDestroyMethodName()`, `DestructionAwareBeanPostProcessor`

### getDestructionCallback

    public java.lang.Runnable getDestructionCallback(java.lang.String name,
                                                     boolean remove)

  Returns the destruction callback, if any registered for the attribute with the given name or `null` if no such callback was registered.

  Parameters:
    `name` - the name of the registered callback requested
    `remove` - `true`, if the callback should be removed after this call, `false`, if it stays
  Returns:
    the callback, if found, `null` otherwise

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD